
// EX2Dlg.cpp : implementation file
//

#include "stdafx.h"
#include "EX2.h"
#include "EX2Dlg.h"
#include "mm.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif


// CEX2Dlg dialog
CEX2Dlg::CEX2Dlg(CWnd* pParent /*=NULL*/)
: CDialog(CEX2Dlg::IDD, pParent)
{
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
	_ode = NULL;
	_ogl = NULL;

	_ctrlDlg = NULL;
}

void CEX2Dlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
}

BEGIN_MESSAGE_MAP(CEX2Dlg, CDialog)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	//}}AFX_MSG_MAP
	ON_WM_SIZE()
	ON_WM_DESTROY()
	ON_WM_TIMER()
	ON_BN_CLICKED(IDC_BUTTON_CTRL, &CEX2Dlg::OnBnClickedButtonCtrl)
END_MESSAGE_MAP()


BOOL CEX2Dlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon

	// OpenGL ׸ ȭ ũ⸦ ´.
	// ⼭ Ŭ̾Ʈ   ư ִ    ´.
	CRect rect;
	GetClientRect(rect);
	rect.top += 40;

	// ODE ü Ѵ.
	_ode = new COde ();

	//ü  
	//AddBox, AddSphere, AddCylinder ̿Ͽ ü ġ ũ  Ư¡ 
	//AttachBallJoint, AttachFixedJoint  ̿Ͽ  ü Joint

	//               name, mass, color(R,G,B), 		 Position(x, y, z), Attitude(roll, pitch, yaw),		   Size(dx, dy, dz)
	_ode->AddBox		("BODY",		30,  RGB(127, 127, 127),	0,     0,     0.12,		_DEG2RAD*0,  _DEG2RAD*0, _DEG2RAD*0,	0.3, 0.3, 0.08);
	_ode->AddCylinder	("LEFT_WHEEL",	1,   RGB(255, 255, 255),	0.05,  0.18,  0.06,		_DEG2RAD*90, _DEG2RAD*0, _DEG2RAD*0,	0.06, 0.03);
	_ode->AddCylinder	("RIGHT_WHEEL",	1,   RGB(255, 255, 255),	0.05,  -0.18, 0.06,		_DEG2RAD*90, _DEG2RAD*0, _DEG2RAD*0,	0.06, 0.03);
	_ode->AddBox		("CASTER_P",	0.5, RGB(255, 255, 127),	-0.16, 0.,  0.07,		_DEG2RAD*0,  _DEG2RAD*0, _DEG2RAD*0,	0.05, 0.03, 0.01);
	_ode->AddCylinder	("CASTER",		0.5, RGB(255, 255, 255),	-0.18, 0.,  0.03,		_DEG2RAD*90, _DEG2RAD*0, _DEG2RAD*0,	0.03, 0.01);

	// lo  hi  Ŭ , hinge joint ȸ Ѱ(limit) üũ ʴ´.
	_ode->AttachHingeJoint	("LWHEEL_JOINT", "BODY", "LEFT_WHEEL",		0., -1., 0., 	0.05,  0.18,  0.06,		100);
	_ode->AttachHingeJoint	("RWHEEL_JOINT", "BODY", "RIGHT_WHEEL",		0., -1., 0.,	0.05,  -0.18, 0.06,		100);
	_ode->AttachHingeJoint	("CAST_JOINT1", "BODY", "CASTER_P",			0., 0., 1.,		-0.14, 0., 0.07,		0);
	_ode->AttachHingeJoint	("CAST_JOINT2", "CASTER_P", "CASTER",		0., 1., 0.,		-0.18, 0., 0.03,		0);

	// ODE ׸  OpenGL ü Ѵ.
	_ogl = new COdeOgl(_ode, "ODE", rect, this, 90000);
	_ogl->_showAxis = true;

	SetTimer (1000, 10, NULL);

	return TRUE;  // return TRUE  unless you set the focus to a control
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CEX2Dlg::OnPaint()
{
	if (IsIconic()) 
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, reinterpret_cast<WPARAM>(dc.GetSafeHdc()), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this function to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CEX2Dlg::OnQueryDragIcon()
{
	return static_cast<HCURSOR>(m_hIcon);
}

void CEX2Dlg::OnSize(UINT nType, int cx, int cy)
{
	CDialog::OnSize(nType, cx, cy);

	//   ũⰡ ٲ , OpenGL  ũ⸦ Ѵ.
	_ogl->MoveWindow (0, 40, cx, cy-40);
}

void CEX2Dlg::OnDestroy()
{
	CDialog::OnDestroy();

	if(_ctrlDlg) {
		_ctrlDlg->DestroyWindow ();
		delete _ctrlDlg;
	}

	_ogl->DestroyWindow ();
	delete _ogl;

	delete _ode;
}


void CEX2Dlg::OnTimer(UINT_PTR nIDEvent)
{
	// ODE ùķ̼   Ѵ.
	_ode->Step (0.01);
	// ùķ̼  OpenGL 쿡 Ʈ Ѵ.
	_ogl->UpdateWnd ();

	CDialog::OnTimer(nIDEvent);
}

void CEX2Dlg::OnBnClickedButtonCtrl()
{
	if(_ctrlDlg != NULL) {
		_ctrlDlg->SetFocus();
		_ctrlDlg->ShowWindow(SW_SHOW);
	}
	else {
		_ctrlDlg = new CControlDlg;
		_ctrlDlg->Create(IDD_DIALOG_CONTROL, this);
		_ctrlDlg->ShowWindow(SW_SHOW);	
	}	
}
